var profile = require('./profile');


module.exports = {
    loadProfile: function(req, res, next) {
        
        var profileData = req.app.stores.getDatabase('profile');
        
        req.getProfile = function(/* [key], fn */) {
            var fn = getCallback(arguments);
            var key = 'profile_' + req.session.username;
            var outerArgs = arguments;
            profileData.getDoc(key, function(err, profile) {
                prependArgument(outerArgs, profile);
                if (!err) {
                    var _profile = getValue.apply(this, outerArgs);
                    fn(_profile);
                } else if (err) {
                    var args = parseGetArgs(outerArgs);
                    if (args.key != null) {
                        fn(null);
                    } else {
                        fn({
                            documentType: 'profile'
                        });
                    }
                }
            });
        };
        req.setProfile = function(/* [key], val, fn */) {
            var fn = getCallback(arguments);
            var outerArgs = arguments;
            var self = this;
            req.getProfile(function(profile) {
                prependArgument(outerArgs, profile);
                setValue.apply(self, outerArgs);
                var args = parseSetArgs(outerArgs);
                var _profile = args.obj;
                _profile._rev = profile._rev;
                var dbKey = 'profile_' + profile.username;
                profileData.saveDoc(dbKey, _profile, function(err, ok) {
                    fn && fn(err, ok);
                });
            });
        };
        next();
    }
};
