var Args = require('vargs').Constructor;
var underscore = require('underscore');

parseSetArgs = exports.parseSetArgs = function(_args) {
    var rawArgs = new(Args)(_args);
    var args = {
        fn: rawArgs.callback,
        obj: rawArgs.all[0]
    };
    if (rawArgs.length <= 2) {
        args.key = null;
        args.val = rawArgs.all[1];
    } else {
        args.key = rawArgs.all[1];
        args.val = rawArgs.all[2];
    }
    return args;
}

parseGetArgs = exports.parseGetArgs = function(_args) {
    var rawArgs = new(Args)(_args);
    var args = {
        fn: rawArgs.callback,
        obj: rawArgs.all[0]
    };
    if (rawArgs.length == 1) {
        args.key = null;
    } else if (rawArgs.length == 2) {
        args.key = rawArgs.all[1];
    }
    return args;
}

findNamespace = exports.findNamespace = function(args, includeTop) {
    if (_.isUndefined(includeTop)) {
        includeTop = true;
    }
    if (args.key == null) {
        return args.obj;
    } else {
        var scopeParts = args.key.split('.');
        var namespace = args.obj;
        var top = includeTop ? scopeParts.length : (scopeParts.length - 1);
        for (var i = 0; i < top; i++) {
            namespace = namespace[scopeParts[i]];
        }
        return namespace;
    }
}

setValue = exports.setValue = function(/* obj, [key], val, fn */) {
    var args = parseSetArgs(arguments);
    if (args.key == null) {
        if (typeof args.val == 'object') {
            _.each(args.val, function(val, key) {
                args.obj[key] = val;
            });
        } else {
            args.obj = args.val;
        }
    } else {
        var space = findNamespace(args, false);
        var keyParts = args.key.split('.');
        var topKey = keyParts[(keyParts.length - 1)];
        space[topKey] = args.val;
    }
}

getValue = exports.getValue = function(/* obj, [key], fn */) {
    var args = parseGetArgs(arguments);
    var space = findNamespace(args);
    return space;
}
