var namespaces = require('./namespaces');
var Args = require('vargs').Constructor;

getCallback = exports.getCallback = function(args) {
    var _args = new(Args)(args);
    var fn = _args.callback;
    return fn;
};

prependArgument = exports.prependArgument = function(args, obj) {
    for (var i = args.length; i > 0; i--) {
        args[i] = args[(i-1)];
    }
    args[0] = obj;
};

unshiftArgument = exports.unshiftArgument = function(args) {
    for (var i = 0; i < args.length; i++) {
        args[i] = args[(i+1)];
    }
    delete args[(args.length - 1)];
};

// For updating the profile outside of a request
// Note: It's a lot like the setProfile in middleware but I think 
// it would be way too hard to follow if I made one function for both.
updateProfile = exports.updateProfile = function(app, username, key, val, fn) {
    var profileData = app.stores.getDatabase('profile');
    var profileIn = profile;
    var fnIn = fn;
    var usernameIn = username;
    var outerArgs = arguments;
    unshiftArgument(arguments);
    unshiftArgument(arguments);
    var dbKey = 'profile_' + usernameIn;
    profileData.getDoc(dbKey, function(err, profile) {
        prependArgument(outerArgs, profile);
        if (!err) {
            setValue.apply(this, outerArgs);
            profileData.saveDoc(dbKey, profile, function(err, ok) {
                fnIn && fnIn(err, ok);
            });
        } else {
            console.log('Error in updateProfile');
            console.dir(err);
            fnIn && fnIn(null);
        }
    });
};
