var fs = require('fs');
var spawn = require('child_process').spawn;
var strings = require('underscore.strings');

parseOptions = exports.parseOptions = function(obj, options, defaults) {
    var o = {};
    _.extend(o, defaults, options);
    _.each(_.keys(defaults), function(key) {
        obj[key] = o[key];
    });
};

jsonFromFile = exports.jsonFromFile = function(filePath) {
    var objStr;
    try {
        objStr = fs.readFileSync(filePath, 'utf8');
    } catch(err) {
        return null;
    }
    return JSON.parse(objStr);
};

getEnvironment = exports.getEnvironment = function(fn) {
    var hostnameCmd = spawn('hostname');
    hostnameCmd.stdout.on('data', function(data) {
        var host = _.trim(''+data);
        var env = _.contains(host, 'local') ? 'dev' : 'live';
        fn(env);
    });
};
